apps/mascota/urls.py
from django.urls import path
from apps.mascota.views import index, mascota_view, mascota_list, mascota_edit, mascota_delete, \
    MascotaList, MascotaCreate, MascotaUpdate, MascotaDelete
from django.contrib.auth.decorators import login_required

app_name = "mascota"
urlpatterns = [
    path('', index, name='index'),
    # path('nuevo', mascota_view, name='mascota_crear'),
    path('nuevo', login_required(MascotaCreate.as_view()), name='mascota_crear'),
    # path('listar', mascota_list, name='mascota_listar'),
    path('listar', login_required(MascotaList.as_view()), name='mascota_listar'),
    # path('editar/<id_mascota>', mascota_edit, name='mascota_editar'),
    path('editar/<pk>', login_required(MascotaUpdate.as_view()), name='mascota_editar'),
    path('eliminar/<pk>', login_required(MascotaDelete.as_view()), name='mascota_eliminar'),
]

refugio/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth.views import LoginView, logout_then_login, PasswordResetView, PasswordResetDoneView, PasswordResetConfirmView, PasswordResetCompleteView


urlpatterns = [
    path('admin/', admin.site.urls),
    path('mascota/', include('apps.mascota.urls'), name='mascota'),
    path('solicitud/', include('apps.adopcion.urls'), name='solicitud'),
    path('usuario/', include('apps.usuario.urls'), name='usuario'),
    path('accounts/login/', LoginView.as_view(), name='login'),
    path('logout', logout_then_login, name='logout'),

    path('password_reset/reset', PasswordResetView.as_view(), name='password_reset'),
    path('password_reset/done', PasswordResetDoneView.as_view(), name='password_reset_done'),
    path('password_reset/confirm/<uidb64>/<token>', PasswordResetConfirmView.as_view(), name='password_reset_confirm'),
    path('passwprd_reset/done', PasswordResetCompleteView.as_view(), name='password_reset_complete'),
]

apps/mascota/models.py
from django.db import models
from apps.adopcion.models import Persona
# Create your models here.

class Vacuna(models.Model):
    nombre = models.CharField(max_length=50)
    def __str__(self):
        return '{}'.format(self.nombre)


class Mascota(models.Model):
    nombre = models.CharField(max_length=50)
    sexo = models.CharField(max_length=10)
    edad_aproximada = models.IntegerField()
    fecha_rescate = models.DateField()
    persona = models.ForeignKey(Persona, null=True, blank=True, on_delete=models.CASCADE)
    #persona = models.OneToOneField(Persona, null=True, blank=True, on_delete=models.CASCADE())
    vacuna = models.ManyToManyField(Vacuna,blank=True)

apps/mascota/forms.py
from django import forms
from apps.mascota.models import Mascota
class MascotaForm(forms.ModelForm):
    class Meta:
        model = Mascota

        fields = [
            'nombre',
            'sexo',
            'edad_aproximada',
            'fecha_rescate',
            'persona',
            'vacuna',
        ]

        labels = {
            'nombre': 'Nombre',
            'sexo': 'Sexo',
            'edad_aproximada': 'Edad aproximada',
            'fecha_rescate': 'Fecha de rescate',
            'persona': 'Adoptante',
            'vacuna': 'Vacunas',
        }

        widgets = {
            'nombre': forms.TextInput(attrs={'class':'form-control'}),
            'sexo': forms.TextInput(attrs={'class':'form-control'}),
            'edad_aproximada': forms.TextInput(attrs={'class':'form-control'}),
            'fecha_rescate': forms.TextInput(attrs={'class':'form-control'}),
            'persona': forms.Select(attrs={'class':'form-control'}),
            'vacuna': forms.CheckboxSelectMultiple(),
        }

apps/mascota/views.py
from django.shortcuts import render,redirect
from django.http import HttpResponse
from django.urls import reverse,reverse_lazy
from django.views.generic import ListView,CreateView, DeleteView, UpdateView

from apps.mascota.forms import MascotaForm
from apps.mascota.models import Mascota


# Create your views here.

def index(request):
    return render(request,'mascota/index.html')

def mascota_view(request):
    if request.method == 'POST':
        form = MascotaForm(request.POST)
        if form.is_valid():
            form.save()
        return redirect('mascota:mascota_listar')
    else:
        form = MascotaForm()

    return render(request,'mascota/mascota_form.html', {'form':form})

def mascota_list(request):
    mascota = Mascota.objects.all().order_by('id')
    contexto = {'mascotas':mascota}
    return render(request,'mascota/mascota_list.html',contexto)

def mascota_edit(request,id_mascota):
    mascota = Mascota.objects.get(id=id_mascota)
    if request.method == 'GET':
        form = MascotaForm(instance=mascota)
    else:
        form = MascotaForm(request.POST, instance=mascota)
        if form.is_valid():
                form.save()
        return redirect('mascota:mascota_listar')
    return render(request, 'mascota/mascota_form.html',{'form':form})

def mascota_delete(request,id_mascota):
    mascota = Mascota.objects.get(id=id_mascota)
    if request.method == 'POST':
        mascota.delete()
        return redirect('mascota:mascota_listar')
    return render(request, 'mascota/mascota_delete.html',{'mascota':mascota})

class MascotaList(ListView):
    model = Mascota
    template_name = 'mascota/mascota_list.html'

class MascotaCreate(CreateView):
    model = Mascota
    form_class = MascotaForm
    template_name = 'mascota/mascota_form.html'
    success_url = reverse_lazy('mascota:mascota_listar')

class MascotaUpdate(UpdateView):
    model = Mascota
    form_class = MascotaForm
    template_name = 'mascota/mascota_form.html'
    success_url = reverse_lazy('mascota:mascota_listar')

class MascotaDelete(DeleteView):
    model = Mascota
    form_class = MascotaForm
    template_name = 'mascota/mascota_delete.html'
    success_url = reverse_lazy('mascota:mascota_listar')




def grado_academico_list(request, id):
    grados = GradoAcademico.objects.filter(docente__id = id)
    contexto = {'grados':grados}
    return render(request,'docentes/grados_list.html',contexto)

templates/mascota/index.html
{% extends 'base/base.html' %}

{% block title %}App mascota{% endblock %}



{% block content %}
    <h5>El contenido de mascota</h5>
{% endblock %}

{% block footer %}
    <h5>Footer de mascota</h5>
{% endblock %}

templates/mascota/mascota_delete.html
{% extends 'base/base.html' %}

{% block content %}
    <form method="post">
        <!--muy importante el token-->
        {% csrf_token %}
        <h3>¿Deseas eliminar el registro de{{ object.nombre }}?</h3>
        <button class="btn btn-danger" type="submit">Eliminar</button>
        <a class="btn btn-default" href="{%  url 'mascota:mascota_listar' %}">Cancelar</a>
    </form>
{% endblock %}

templates/mascota/mascota_form.html
{% extends 'base/base.html' %}

{% block content %}
    <form method="post">
        <!--muy importante el token-->
        {% csrf_token %}

        {{ form.as_p }}
        <button type="submit">Guardar</button>
    </form>
{% endblock %}

templates/mascota/mascota_list.html
{% extends 'base/base.html' %}

{% block content %}
    <table class="table table-bordered">
        <thead>
            <tr>
                <td>#</td>
                <td>Nombre</td>
                <td>Sexo</td>
                <td>Edad</td>
                <td>Fecha de rescate</td>
                <td>Adoptante</td>
                <td>Acciones</td>
            </tr>
        </thead>

        <tbody>
            {% if object_list %}
            {% for mascota in object_list %}
            <tr>
                <td>{{ mascota.id }}</td>
                <td>{{ mascota.nombre }}</td>
                <td>{{ mascota.sexo }}</td>
                <td>{{ mascota.edad_aproximada}}</td>
                <td>{{ mascota.fecha_rescate }}</td>
                <td>{{ mascota.persona.nombre }} {{ mascota.persona.apellidos }}</td>
                <td>
                    <a class="btn-primary btn" href="{% url 'mascota:mascota_editar' mascota.id %}">Editar</a>
                    <a class="btn-danger btn" href="{% url 'mascota:mascota_eliminar' mascota.id %}">Eliminar</a>
                </td>
            </tr>

        {% endfor %}
        {% else %}
        <h1>No hay registros de mascotas</h1>
        {% endif %}

        </tbody>
    </table>
{% endblock %}